#include "mystring.h"

char* strtoupper(char *s)
{
    if(s == NULL)
        return NULL;

    char *tmp = (char*)malloc(sizeof(char)*strlen(s) + 1);
    char *r = tmp;
    while ( (*tmp++ = toupper(*s++)) );
    free(tmp);

    return r;
}

int strpos (char *haystack, char *needle)
{
	char *dest;
	int position;

	dest = (char*)strstr(haystack, needle);

	if (dest) {
		position = dest - haystack;
	} else {
		return -1;
	}
	return position;
}

int stripos (char *haystack, char *needle)
{
    char *tmp_haystack = (char*) malloc(sizeof(char)*strlen(haystack) + 1);
    char *tmp_needle = (char*) malloc(sizeof(char)*strlen(needle) + 1);

    strcpy(tmp_haystack, haystack);
    strcpy(tmp_needle, needle);

    int result = strpos(tmp_haystack, tmp_needle);
    free(tmp_haystack);
    free(tmp_needle);

    return result;
}
